module T1000
  class Lock < Struct.new :ip

    def key
      @key ||= ActiveSupport::Cache.expand_cache_key [ip], :ip_lock
    end

    def lock!(time = 1.minute)
      T1000.cache.store.write(key, true, expires_in: time)
    end

    def locked?
      !!T1000.cache.store.read(key)
    end

  end
end
