module T1000
  class Middleware < Rack::Attack

    extend Forwardable
    def_delegators self, :whitelisted?,
                   :blacklisted?,
                   :throttled?,
                   :tracked?

    def cache
      T1000.cache
    end

    def call(env)
      req          = Request.new(env)
      transactions = TransactionList.for_ip(req.ip)
      super.tap do |status, headers, *|
        transaction = Transaction.new req, Response.new(status, headers)
        transactions.push transaction
      end
    end

  end
end
